# Horizon Advance

horizon-advance is a Package Set targetting GHC mainline, building on top of
[horizon-core](https://gitlab.horizon-haskell.net/package-sets/horizon-core).

While horizon-core only contains packages required to bootstrap the horizon
toolchain, horizon-advance contains packages required for canary testing
any compatibility issues with GHC mainline.

Businesses and individuals who require advance warning of particular
open source packages for compatibility issues are encouraged to file
a request here.

## Package Set Policy

This package set has the following policy.

* GHC will advance as often as possible.
* Non-versioned locations (git, unversioned tarballs) are permitted to allow
  GHC to advance.
* The following packages must always build:
  * polysemy

## Updating the Package set

The package set is generated from the `horizon.dhall` using the following command:

```
nix run 'git+https://gitlab.horizon-haskell.net/haskell/horizon-gen-nix?ref=refs/tags/0.10.0'
```

If you need to do additional manual overrides to the nix code, such as
`addPkgconfigDepends`, edit the `configuration.nix` overlay, which is applied
afterwards.

## Programmmatic Updates

To use `horizon-shell`.

```
nix run 'git+https://gitlab.horizon-haskell.net/shells/horizon-shell?ref=refs/tags/0.0.7'
```

See the in-shell help for usage.
